-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

-- **v Unload v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( 'HugeBag' );
	Turbine.PluginManager.LoadPlugin( 'HugeBag Unloader' );
end
-- **^
-- **v Reload v**
function ReloadHugeBag()
	--write( "HugeBag: Reloaded" );
	--UnloadHugeBag();
	--Turbine.PluginManager.LoadPlugin( 'HugeBag' );
	Turbine.PluginManager.LoadPlugin( 'HugeBag Reloader' );
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	HideWEsc = ( not HideWEsc );
	SaveSettings();
	if ( HideWEsc ) then
		write( "HugeBag: I will hide when 'esc' key is press" );
	else
		write( "HugeBag: I will stay visible when 'esc' key is press" );
	end
end
-- **^
-- **v Toggle Startup Visibility v**
function ToggleShow()
	StartVisible = ( not StartVisible );
	SaveSettings();
	if ( StartVisible ) then
		write( "HugeBag: I will load visibile next time" );
	else
		write( "HugeBag: I will load hidden next time" );
	end
end
-- **^
-- **v Toggle between window and widget mode v**
function ToggleMode()
	Widget = ( not Widget );
	SaveSettings();
	if ( Widget ) then
		write( "HugeBag: Will load in widget mode next time" );
	else
		write( "HugeBag: Will load in window mode next time" );
	end
end
-- **^
-- **v Toggle ability to be always on top are not v**
function ToggleAlwaysOnTop()
	zOrder = ( not zOrder );
	SaveSettings();
	if ( zOrder ) then
		write( "HugeBag: Will be always on top" );
	else
		write( "HugeBag: Will not be always on top" );
	end
end
-- **^
-- **v Toggle inverse merge function v**
function InvMerge()
	InverseMerge = ( not InverseMerge );
	SaveSettings();
	if ( InverseMerge ) then
		write( "HugeBag: Will merge items from slot " .. backpackSize .. " to 1" );
	else
		write( "HugeBag: Will merge items from slot 1 to " .. backpackSize );
	end
end
-- **^
-- **v Searching v**
function Searching()
	SearchInput:SetVisible( not SearchInput:IsVisible() );
	SortButton:SetVisible( false );
	SearchButton:SetVisible( false );
	MergeButton:SetVisible( false );
	ResetAllCheck(); --Reset all itemsmenu check
	SearchInput:Focus();
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.background"; -- LUA background file
	frmBackground();
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.shellcmd"; -- LUA shell command file
	frmShellCmd();
end
-- **^
-- **v Show ListBox items v**
function ShowItems(ItemsToShow)
	if ItemsToShow == "all" then
		SearchInput.FocusLost( sender, args );
	else
		if AllVisible then
			for i = 1, backpackSize do
				Item = Backpack:GetItem( i );
				if Item ~= nil then wHugeBag.items[i]:SetVisible( false ); end
				AllVisible = false;
			end
		end
		for i = 1, backpackSize do
			Item = Backpack:GetItem( i );
			if Item ~= nil then
				ItemType = ItemCategory[Item:GetCategory()];
				if ItemsSel then
					if ItemType == ItemsToShow then	wHugeBag.items[i]:SetVisible( true ); end
				else
					if ItemType == ItemsToShow then	wHugeBag.items[i]:SetVisible( false ); end
				end
			end
		end
	end
end
-- **^
-- **v Move button to right v**
function MoveButton(MoveTo)
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;
	if ( MoveTo == "left" ) then
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == LeftPos then
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		end
	else
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == RightPos then
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		end
	end

	if ( ButtonAtTop ) then
		TopPos = 22;
	else
		TopPos = wHugeBag:GetHeight() - 16;
		if Widget then TopPos = 8; end
	end
	SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
	SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
	MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
	SearchInput:SetPosition( LeftPos,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
	SaveSettings();
end
-- **^
-- **v Move all buttons to left side of window v**
function ButtonsLeft()
	if not ButtonAtLeft then
		if Widget then
			MidPos = 55;
			SortLeft = SortLeft - 225;
			SearchLeft = SearchLeft - 225;
			MergeLeft = MergeLeft - 225;
		else
			Diff = MidPos - 85;
			LeftPos, MidPos, RightPos = 35, 85, 135;
			SortLeft = SortLeft - Diff;
			SearchLeft = SearchLeft - Diff;
			MergeLeft = MergeLeft - Diff;
		end
		
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 16;
			if Widget then TopPos = 8; end
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( LeftPos,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = true;
		SaveSettings();
	end
end
-- **^
-- **v Move all buttons to right side of window v**
function ButtonsRight()
	if ButtonAtLeft then
		if Widget then
			MidPos = 280;
			SortLeft = SortLeft + 225;
			SearchLeft = SearchLeft + 225;
			MergeLeft = MergeLeft + 225;
		else
			Diff = ( WinWidth - 185 ) - LeftPos;
			LeftPos = ( WinWidth - 185 );
			MidPos = LeftPos + 50;
			RightPos = MidPos + 50;
			SortLeft = SortLeft + Diff;
			SearchLeft = SearchLeft + Diff;
			MergeLeft = MergeLeft + Diff;	
		end
		
		if ( ButtonAtTop ) then
			TopPos = 22;
		else
			TopPos = WinHeight - 16;
			if Widget then TopPos = 8; end
		end
		SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
		SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
		MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
		SearchInput:SetPosition( LeftPos,  TopPos - 7 ); --> ** Replace 'Search Box' with HugeBag height **
		ButtonAtLeft = false;
		SaveSettings();
	end
end
-- **^

function LoadItemsCategory()
	ItemsCatDes = {};
	ItemsCatDesType = {};
	ItemsCatDes[1] = "Show Tools";
	ItemsCatDesType[1] = "Tool";
	ItemsCatDes[2] = "Show Devices";
	ItemsCatDesType[2] = "Device";
	ItemsCatDes[3] = "Show Foods";
	ItemsCatDesType[3] = "Food";
	ItemsCatDes[4] = "Show Jewelry";
	ItemsCatDesType[4] = "Jewelry";
	ItemsCatDes[5] = "Show Components";
	ItemsCatDesType[5] = "Component";
	ItemsCatDes[6] = "Show Craft Ingredients";
	ItemsCatDesType[6] = "CraftOptionalIngredient";
	ItemsCatDes[7] = "Show Fishing Pole";
	ItemsCatDesType[7] = "FishingPole";
	ItemsCatDes[8] = "Show Barter & Reputation";
	ItemsCatDesType[8] = "BarterReputation";

end

-- Create ten hacky resize cursors
function createCursor( MyCursorName, xOffset, yOffset, xSize, ySize, InGameCursor )
	cursor = Turbine.UI.Window();
	cursor:SetSize( xSize, ySize );
	if MyCursorName == nil then
		cursor:SetBackground( InGameCursor );
	else
		cursor:SetBackground( "HabnaPlugins/HugeBag/Resources/"..MyCursorName..".tga" );
	end
	cursor:SetMouseVisible( false );
	cursor:SetZOrder( 10 );
	
	cursor.xOffset = xOffset;
	cursor.yOffset = yOffset;
	
	return cursor;
end

-- Widget mode cursor
up_down_right_clic = createCursor( "up_down_right-click", 15, 12, 37, 23, nil );

-- Window mode cursor
resizeCursor = createCursor( nil, 14, 16, 32, 32, 0x410000dd ); -- in-game cursor 32x32: 0x410000dd
updownCursor = createCursor( nil, 18, 16, 32, 32, 0x410081c0 ); -- in-game cursor 32x32: 0x410081c0
leftrightCursor = createCursor( nil, 14, 16, 32, 32, 0x410081bf ); -- in-game cursor 32x32: 0x410081bf
leftrightclicCursor = createCursor( "left-right-click", 15, 15, 18, 22, nil );
--In-game normal cursor 32x32: 0x41007dc7

function ShowLeftRightCursor()
	if not LockSize then
		wHugeBag.cursor = leftrightCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowUpDownCursor()
	if not LockSize then
		wHugeBag.cursor = updownCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowTitleResizeCursor()
	if not LockPosition then
		wHugeBag.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowResizeCursor()
	if not LockSize then
		wHugeBag.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
		wHugeBag.cursor:SetVisible( true );
	end
end

function ShowResizeRightClicCursor()
	if not LockSize then
		wHugeBag.cursor = resizeRightClicCursor;
	else
		wHugeBag.cursor = rightclicCursor;
	end
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	wHugeBag.cursor:SetPosition( mouseX - wHugeBag.cursor.xOffset, mouseY - wHugeBag.cursor.yOffset);
	wHugeBag.cursor:SetVisible( true );
end

function mergetable(table1,list)
	for i = 1, #list do
		table2 = list[i];
		local LenTable1 = #table1;
		for a = LenTable1 + 1, #table1 + #table2 do
			table1[a] = table2[a - LenTable1];
		end
	end
end

function ChangeColor()
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, curSelRed, curSelGreen, curSelBlue ) );
end

-- For debug purpose
function ShowTableContent(args)
	for k,v in pairs(args) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end