-- functionsWidget.lua
-- Written By Habna


-- **v Save Widget Location v**
function WidLoc(ToSide)
	if ToSide == "right" then
		if windowOpen then
			wHugeBag:SetLeft( screenWidth - ( winRate * 15 ) );
		else
			wHugeBag:SetLeft( screenWidth - 30 );
		end
	elseif ToSide == "left" then
		if windowOpen then
			wHugeBag:SetLeft( 1 );
		else
			wHugeBag:SetLeft( -419 );
		end
	end
	WidgetLoc = ToSide;
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Show HugeBag v**
function ShowHugeBag()
	if ( windowOpen ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		slideCtr:SetWantsUpdates(true);
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Toggle top bar info v**
function ToggleTopBarInfo(value)
	if value == "title" then
		write( "HugeBag: Showing title on my top bar" );
	elseif value == "info" then
		write( "HugeBag: Showing info on my top bar" );
	elseif value == "nil" then
		write( "HugeBag: Showing nothing on my top bar" );
	end
	topbarinfo = value;
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Toggle side bar info v**
function ToggleSideBarInfo(value)
	if value == "image" then
		write( "HugeBag: Showing image on my side bar" );
	elseif value == "info" then
		write( "HugeBag: Showing info on my side bar" );
	elseif value == "nil" then
		write( "HugeBag: Showing nothing on my side bar" );
	end
	sidebarinfo = value;
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Toggle bottom bar info v**
function ToggleBotBarInfo(value)
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't show/hide buttons when sort, mix, merge or search function are active!");
		return
	end
	if value == "butvis" then
		ShowButton = not ShowButton;
		if ShowButton then
			write( "HugeBag: Buttons are now visible" );
		else
			write( "HugeBag: Buttons are now invisible" );
		end
	end
	PrintTitle();
	SaveSettings();
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not windowOpen ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		slideCtr:SetWantsUpdates(true);
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Move all buttons to left side of window v**
function ButtonsLeft()
	if not ButtonAtLeft then
		Diff = MidPos - 55;
		LeftPos, MidPos, RightPos = 5, 55, 105;
		SortLeft = SortLeft - Diff;
		SearchLeft = SearchLeft - Diff;
		MergeLeft = MergeLeft - Diff;
		SortButton:SetPosition( SortLeft,  8 );
		SearchButton:SetPosition( SearchLeft,  8 );
		MergeButton:SetPosition( MergeLeft, 8 );
		SearchInput:SetPosition( SortLeft,  4 );
		ButtonAtLeft = true;
		SaveSettings();
	end
end
-- **^
-- **v Move all buttons to right side of window v**
function ButtonsRight()
	if ButtonAtLeft then
		Diff = ( WinWidth - 215 ) - LeftPos;
		LeftPos = ( WinWidth - 215 );
		MidPos = LeftPos + 50;
		RightPos = MidPos + 50;
		SortLeft = SortLeft + Diff;
		SearchLeft = SearchLeft + Diff;
		MergeLeft = MergeLeft + Diff;
		SortButton:SetPosition( SortLeft,  8 );
		SearchButton:SetPosition( SearchLeft,  8 );
		MergeButton:SetPosition( MergeLeft, 8 );
		SearchInput:SetPosition( SortLeft,  4 );
		ButtonAtLeft = false;
		SaveSettings();
	end
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show"
	ShellCommandName[2]= "hide"
	ShellCommandName[3]= "unload"
	ShellCommandName[4]= "reload"
	ShellCommandName[5]= "resetall"
	ShellCommandName[6]= "wesc"
	ShellCommandName[7]= "visible"
	ShellCommandName[8]= "mode"
	ShellCommandName[9]= "aot";
	ShellCommandName[10]= "buttons";
	ShellCommandName[11]= "sort"
	ShellCommandName[12]= "merge"
	ShellCommandName[13]= "inversemerge"
	ShellCommandName[14]= "about"
	ShellCommandName[15]= "help/?"
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag"
	ShellCommandDes[2]= "Hide HugeBag"
	ShellCommandDes[3]= "Unload HugeBag"
	ShellCommandDes[4]= "Reload HugeBag"
	ShellCommandDes[5]= "Reset all settings to default"
	ShellCommandDes[6]= "Toggle hide HugeBag event when the 'esc' key is press"
	ShellCommandDes[7]= "Show or hide HugeBag at startup"
	ShellCommandDes[8]= "Toggle between widget and window mode"
	ShellCommandDes[9]= "Toggle HugeBag ability to be always on top are not";
	ShellCommandDes[10]= "Toggle all buttons visibility";
	ShellCommandDes[11]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[12]= "Merge stackable items into one stack item"
	ShellCommandDes[13]= "Inverse the merge function (Default slot 1 to 75)"
	ShellCommandDes[14]= "Show the 'About' window"
	ShellCommandDes[15]= "Show HugeBag shell commands/?"
end