-- functions.lua
-- Written By Habna


-- **v Hide HugeBag v**
function ShowHugeBag()
	if ( frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already visible" );
	else
		frmMain:SetVisible( true );
		--write( "HugeBag: I'm now visible" );
	end
end
-- **^
-- **v Hide HugeBag v**
function HideHugeBag()
	if ( not frmMain:IsVisible() ) then
		write( "HugeBag: Impossible, I'm already hidden" );
	else
		frmMain:SetVisible( false );
		--write( "HugeBag: I'm now hidden" );
	end
end
-- **^
-- **v Show Settings window v**
function ShowCurrentSettings()
	import "HabnaPlugins.HugeBag.contextMenu"; -- LUA contextual menu file
	contextMenu();
end
-- **^
-- **v Toggle Slots Info v**
function ToggleSlotsInfo()
	ShowSlotsInfo = ( not ShowSlotsInfo );
	SaveSettings();
	PrintTitle();
	--[[
	if ( ShowSlotsInfo ) then
		write( "HugeBag: Now showing slots informations in the title" );
	else
		write( "HugeBag: Not showing slots informations in the title" );
	end
	]]
end
-- **^
-- **v Toggle Items Orientation v**
function ToggleItemsOrientation()
	HorizontalOrientation = ( not HorizontalOrientation );
	PerformLayout();
	SaveSettings();
end
-- **^
-- **v Toggle 'Sort/Merge/Search' button on & off v**
function ToggleButton()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't show/hide buttons when sort, mix, merge or search function are active!");
		return
	end
	ShowButton = ( not ShowButton );
	SaveSettings();
	if ShowButton then
		write( "HugeBag: All buttons are visible now" );
		SortButton:SetVisible( true );
		SearchButton:SetVisible( true );
		MergeButton:SetVisible( true );
	else
		write( "HugeBag: All buttons are NOT visible now" );
		SortButton:SetVisible( false );
		SearchButton:SetVisible( false );
		MergeButton:SetVisible( false );
	end
end
-- **^
--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
-- **v Toggle Items ReverseFill v**
function ToggleItemsReverseFill()
	ReverseFill = ( not ReverseFill );
	frmMain.itemListBox:SetReverseFill( ReverseFill );
	frmMain:PerformLayout();
	SaveSettings();
end
-- **^
]]
-- **v Lock HugeBag Position v**
function LockHugeBagSize()
	LockSize = ( not LockSize );
	SaveSettings();
	--[[
	if ( LockSize ) then
		write( "HugeBag: My size is now lock." );
	else
		write( "HugeBag: My size is now unlock." );
	end
	]]
end
-- **^
-- **v Lock HugeBag Position v**
function LockHugeBagPosition()
	LockPosition = ( not LockPosition );
	LockLabel.Enable = not LockPosition;
	SaveSettings();
	--[[
	if ( LockPosition ) then
		--write( "HugeBag: My position is now lock." );
	else
		--write( "HugeBag: My position is now unlock." );
	end
	]]
end
-- **^
-- **v Options List v**
function LoadListOptionsName()
	OptionNameList = {};
	OptionNameList[1]= "Show 'free/used/max' info in title? ";
	OptionNameList[2]= "Start HugeBag visible at startup? ";
	OptionNameList[3]= "Hide HugeBag when 'esc' key is press? ";
	OptionNameList[4]= "Lock HugeBag size? ";
	OptionNameList[5]= "Lock HugeBag position? ";
	OptionNameList[6]= "HugeBag mode? ";
	OptionNameList[7]= "Show HugeBag skin? ";
	OptionNameList[8]= "Orientation of items? ";
	--OptionNameList[10]= "Reverse fill the items? ";
	OptionNameList[9]= "HugeBag always on top? ";
	OptionNameList[10]= "Show 'Sort/Merge/Search' buttons? ";
	OptionNameList[11]= "Inverse merge function? ";
end
-- **^
-- **v Shell command List v**
function LoadShellCommandName()
	ShellCommandName = {};
	ShellCommandName[1]= "show";
	ShellCommandName[2]= "hide";
	ShellCommandName[3]= "unload";
	ShellCommandName[4]= "reload";
	ShellCommandName[5]= "resetls";
	ShellCommandName[6]= "resetall";
	ShellCommandName[7]= "wesc";
	ShellCommandName[8]= "visible";
	ShellCommandName[9]= "mode";
	ShellCommandName[10]= "slots";
	ShellCommandName[11]= "skin";
	ShellCommandName[12]= "aot";
	ShellCommandName[13]= "buttons";
	ShellCommandName[14]= "orientation";
	--ShellCommandName[15]= "reversefill";
	ShellCommandName[15]= "options";
	ShellCommandName[16]= "locksize";
	ShellCommandName[17]= "lockpos";
	ShellCommandName[18]= "sort"
	ShellCommandName[19]= "merge"
	ShellCommandName[20]= "inversemerge"
	ShellCommandName[21]= "about";
	ShellCommandName[22]= "help";
end
-- **^
-- **v Shell Command description list v**
function LoadShellCommandDes()
	ShellCommandDes = {};
	ShellCommandDes[1]= "Show HugeBag";
	ShellCommandDes[2]= "Hide HugeBag";
	ShellCommandDes[3]= "Unload HugeBag";
	ShellCommandDes[4]= "Reload HugeBag";
	ShellCommandDes[5]= "Reset location and size settings to default";
	ShellCommandDes[6]= "Reset all settings to default";
	ShellCommandDes[7]= "Toggle hide HugeBag event when the 'esc' key is press";
	ShellCommandDes[8]= "Show or hide HugeBag at startup";
	ShellCommandDes[9]= "Toggle between widget and window mode";
	ShellCommandDes[10]= "Show or hide slots information in title";
	ShellCommandDes[11]= "Toggle HugeBag skin on and off";
	ShellCommandDes[12]= "Toggle HugeBag ability to be always on top are not";
	ShellCommandDes[13]= "Toggle all buttons visibility on & off";
	ShellCommandDes[14]= "Toggle items oriention";
	--ShellCommandDes[16]= "Toggle reverse fill of items (NOT WORKING)";
	ShellCommandDes[15]= "Show HugeBag Options";
	ShellCommandDes[16]= "Lock/unlock HugeBag size";
	ShellCommandDes[17]= "Lock/unlock HugeBag position";
	ShellCommandDes[18]= "Sort HugeBag items (Courtesy of MrJackdaw)"
	ShellCommandDes[19]= "Merge stackable items into one stack"
	ShellCommandDes[20]= "Inverse the merge function (Default slot 1 to 75)"
	ShellCommandDes[21]= "Show the 'About' window";
	ShellCommandDes[22]= "Show HugeBag shell commands";
end
-- **^

function ToggleSkin()
	ShowSkin = ( not ShowSkin );

	HBSkin:SetVisible( not ShowSkin );

	if ( ShowSkin ) then
		SortButton:SetPosition( SortLeft,  WinHeight - 16 );
		SearchButton:SetPosition( SearchLeft,  WinHeight - 16 );
		MergeButton:SetPosition( MergeLeft, WinHeight - 16 );
		SearchInput:SetPosition( LeftPos,  WinHeight - 23 );
	else
		SortButton:SetPosition( SortButton:GetLeft(), 23 );
		SearchButton:SetPosition( SearchButton:GetLeft(), 23 );
		MergeButton:SetPosition( MergeButton:GetLeft(), 23 );
		SearchInput:SetPosition( LeftPos,  16 );
	end
	
	ButtonAtTop = not ShowSkin;
	SaveSettings();
end