-- Main.lua
-- Originally written by Rod, extended by Habna


import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

Version = "1.4.49"; --> ** HugeBag current version **

AllVisible = true; --> All items are visible by default
IsSorting, IsMixing, IsMerging, IsMoving = false, false, false, false;
screenWidth, screenHeight = Turbine.UI.Display.GetSize(); --> ** Get the display size **
write = Turbine.Shell.WriteLine; --> To shorten the writeline command

Modesettings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagMode" );

-- **v no setting found, so create it v**
if Modesettings == nil then
	Modesettings = {};
	Modesettings.Widget = true;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^

Widget = Modesettings.Widget;

-- import for both mode
import "HabnaPlugins.HugeBag";
import "HabnaPlugins.HugeBag.Class";
import "HabnaPlugins.HugeBag.functions"; -- LUA functions file
import "HabnaPlugins.HugeBag.color"; -- LUA color file
import "HabnaPlugins.HugeBag.sortingList"; -- LUA sorting list file
import "HabnaPlugins.HugeBag.sort"; -- LUA Sort file
import "HabnaPlugins.HugeBag.mix"; -- LUA Mix file
import "HabnaPlugins.HugeBag.search"; -- LUA Search file
import "HabnaPlugins.HugeBag.merge"; -- LUA Merge file
import "HabnaPlugins.HugeBag.buttonmenu"; -- LUA Button Menu file
import "HabnaPlugins.HugeBag.itemsmenu"; -- LUA items Menu file
import "HabnaPlugins.HugeBag.OptionPanel"; -- LUA option panel file (for in-game plugin manage options tab)

if ( Widget ) then
	import "HabnaPlugins.HugeBag.mainWidget";
else
	import "HabnaPlugins.HugeBag.mainWindow";
end

frmMain = frmMain();
--frmMain();

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( Widget ) then -- Commands for widget mode
		if ( arguments == "options" ) then
			menu:ShowMenuAt(frmMain:GetLeft() - 338, frmMain:GetTop());
		elseif ( arguments == "buttons" or arguments == "button" ) then
			ToggleBotBarInfo("butvis");
		end
	else -- Commands for window mode
		if ( arguments == "resetls" ) then
			ResetLSSettings();
		elseif ( arguments == "slots" ) then
			ToggleSlotsInfo();
		elseif ( arguments == "skin" ) then
			ToggleSkin();
		elseif ( arguments == "buttons" or arguments == "button" ) then
			ToggleButton();
		elseif ( arguments == "orientation" ) then
			ToggleItemsOrientation();
		-- Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
		--elseif ( arguments == "reversefill" ) then
			--ToggleItemsReverseFill();
		elseif ( arguments == "options" ) then
			frmOptions();
		elseif ( arguments == "locksize" ) then
			LockHugeBagSize();
		elseif ( arguments == "lockpos" or arguments == "lockposition") then
			LockHugeBagPosition();
		end
	end

	-- Commands for both mode
	if ( arguments == "show" ) then
		ShowHugeBag();
	elseif ( arguments == "hide" ) then
		HideHugeBag();
	elseif ( arguments == "unload" ) then
		UnloadHugeBag();
	elseif ( arguments == "reload" ) then
		ReloadHugeBag();
	elseif ( arguments == "wesc" ) then
		ToggleWEsc();
	elseif ( arguments == "visible" ) then
		ToggleShow();
	elseif ( arguments == "mode" ) then
		ToggleMode();
	elseif ( arguments == "aot" or arguments == "alwaysontop" ) then
		ToggleAlwaysOnTop();
	elseif ( arguments == "sort" ) then
		Sort();
	elseif ( arguments == "merge" ) then
		Merge();
	elseif ( arguments == "mix" ) then
		Mix();
	elseif ( arguments == "about" ) then
		write( "HugeBag: Please use the in-game plugin manager to see the about information" );
	elseif ( arguments == "help" or arguments == "?") then
		HelpInfo();
	elseif ( arguments == "inversemerge" ) then
		InvMerge();
	--elseif ( arguments == "debug" ) then
		--import "HabnaPlugins.HugeBag.debugwin";
		--frmDebug();
	elseif ( arguments == "resetall" ) then
			ResetSettings();
	--else
		--write( "HugeBag: Command not supported" );
	end
end

Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );
--write("HugeBag v" .. Version .. " by Habna");

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
end