-- merge.lua
-- Written By Habna


function Merge()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't merge when sort, mix, merge or search function are active!");
		return
	end
	
	iFirst, iLast, iStep = 1, backpackSize, 1;
	if InverseMerge then iFirst, iLast, iStep = backpackSize, 1, -1; end
	DestSlot = iFirst;
	
	IsMerging = true;
	SortButton:SetVisible( false );
	SearchButton:SetVisible( false );
	MergeButton:SetVisible( false );
	write( "HugeBag: Merging started" );
	
	FirstStart= Turbine.Engine.GetGameTime()
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates( true );

	Timer.Update = function( sender, args )
		if DestSlot < 1 or DestSlot > backpackSize then
			Timer:SetWantsUpdates( false );

			if ShowButton then
				SortButton:SetVisible( true );
				SearchButton:SetVisible( true );
				MergeButton:SetVisible( true );
			end
			
			IsMerging = false;
			write( "HugeBag: Merging finished" );
			--Turbine.PluginManager.LoadPlugin( 'HugeBag Reloader' );
			--local Time = Turbine.Engine.GetGameTime();
			--write("<rgb=#888888>Merge finished after ".. Time - FirstStart .." seconds.")
		end
		
		if DestSlot < 1 or iLast > backpackSize then return end
		
		--Get the name of the destination item
		TargetItem = Backpack:GetItem(DestSlot);
		TargetName = "zEmpty";
		if TargetItem ~= nil then TargetName = TargetItem:GetName(); TargetItemQuantity = TargetItem:GetQuantity(); end
		
		for SourceSlot = iFirst, iLast, iStep do
			--Get the name of the source item
			SourceItem = Backpack:GetItem(SourceSlot);
			SourceName = "zEmpty";
			if SourceItem ~= nil then
				SourceName = SourceItem:GetName();
				ItemMaxStackSize = SourceItem:GetMaxStackSize();
				ItemQuantity = SourceItem:GetQuantity();
			end
			
			--write(tostring("Target: " .. TargetItemQuantity .. " " .. TargetName .. " at " .. DestSlot));
			--write(tostring("Source: " .. ItemQuantity .. " " .. SourceName .. " at " .. SourceSlot));
			
			if SourceName == TargetName and SourceName ~= "zEmpty" then
				if ItemMaxStackSize ~= 1 and ItemQuantity < ItemMaxStackSize then
					if Lasti == SourceSlot then
						Lasti = nil;
						SourceSlot = SourceSlot - 1;
					else
						item = Backpack:GetItem( SourceSlot );
						if item ~= nil then	Backpack:PerformItemDrop( item, DestSlot, false ); end
						Lasti = SourceSlot; --Last item move (slot number)
					end
				end
			end
		end
		if not InverseMerge then DestSlot = DestSlot + 1; else DestSlot = DestSlot - 1; end
	end
end