-- options.lua
-- Written by Habna


function frmOptions()
	wOptions = Turbine.UI.Lotro.Window();
	--wOptions = Turbine.UI.Lotro.GoldWindow();
	
	-- **v Set backcolor, position, size and text of the window v**
	NumOptTop = 11; --> Number of options in the top section (White options)
	NumOptions = 17; --> Total number of options (white + green)

	wOptions:SetSize( 360, (NumOptions * 20 + 60) );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = wOptions:GetSize();
	local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight /2 );
    wOptions:SetPosition( left, top );
	wOptions:SetText( "HugeBag Window Options" );
	wOptions:SetBackColor( Turbine.UI.Color() );
	wOptions:SetVisible( true );
	--wOptions:SetZOrder( 2 );
	wOptions:Activate();
	-- **^

	LoadListOptionsName()

	--**v Options Label v**
	local PosY = 40;
	for i = 1, NumOptTop do
		local label1q = Turbine.UI.Label();
		label1q:SetParent( wOptions );
		label1q:SetText( OptionNameList[i] );
		label1q:SetPosition( 15, PosY );
		label1q:SetSize( string.len(label1q:GetText()) * 7.2, 18 ); --Auto size with text lenght
		label1q:SetForeColor( white );
		label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		PosY = PosY + 20;
	end
	--**^
	PosY = 40;
	--**v Show slots info in title v**
	local OptR1lbl = Turbine.UI.Label();
	OptR1lbl:SetParent( wOptions );
	OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	OptR1lbl:SetPosition( 270, PosY );
	OptR1lbl:SetSize( string.len(OptR1lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR1lbl:SetForeColor( green );
	OptR1lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR1lbl.MouseClick = function(sender, args)
		ToggleSlotsInfo();
		OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
		OptR1lbl:SetSize( string.len(OptR1lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR1lbl.MouseHover = function(sender, args)
		OptR1lbl:SetBackColor( lightgrey );
		OptR1lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR1lbl.MouseLeave = function(sender, args)
		OptR1lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Start visible at startup v**
	local OptR3lbl = Turbine.UI.Label();
	OptR3lbl:SetParent( wOptions );
	OptR3lbl:SetText( tostring( StartVisible ) );
	OptR3lbl:SetPosition( 255, PosY );
	OptR3lbl:SetSize( string.len(OptR3lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR3lbl:SetForeColor( green );
	OptR3lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	--**v Red dot - Start visible v**
	local RedDotLbl1 = Turbine.UI.Label();
	RedDotLbl1:SetParent( wOptions );
	RedDotLbl1:SetText( "*" );
	RedDotLbl1:SetPosition( 6, PosY + 3 );
	RedDotLbl1:SetForeColor( red );
	--**^

	OptR3lbl.MouseClick = function(sender, args)
		ToggleShow();
		OptR3lbl:SetText( tostring( StartVisible ) );
		OptR3lbl:SetSize( string.len(OptR3lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR3lbl.MouseHover = function(sender, args)
		OptR3lbl:SetBackColor( lightgrey );
		OptR3lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR3lbl.MouseLeave = function(sender, args)
		OptR3lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Hide HugeBag when 'esc' key is press v**
	local OptR4lbl = Turbine.UI.Label();
	OptR4lbl:SetParent( wOptions );
	OptR4lbl:SetText( tostring( HideWEsc ) );
	OptR4lbl:SetPosition( 285, PosY );
	OptR4lbl:SetSize( string.len(OptR4lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR4lbl:SetForeColor( green );
	OptR4lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR4lbl.MouseClick = function(sender, args)
		ToggleWEsc();
		OptR4lbl:SetText( tostring( HideWEsc ) );
		OptR4lbl:SetSize( string.len(OptR4lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR4lbl.MouseHover = function(sender, args)
		OptR4lbl:SetBackColor( lightgrey );
		OptR4lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR4lbl.MouseLeave = function(sender, args)
		OptR4lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Size locker activated v**
	local OptR5lbl = Turbine.UI.Label();
	OptR5lbl:SetParent( wOptions );
	OptR5lbl:SetText( tostring( LockSize ) );
	OptR5lbl:SetPosition( 150, PosY );
	OptR5lbl:SetSize( string.len(OptR5lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR5lbl:SetForeColor( green );
	OptR5lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR5lbl.MouseClick = function(sender, args)
		LockHugeBagSize();
		OptR5lbl:SetText( tostring( LockSize ) );
		OptR5lbl:SetSize( string.len(OptR5lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR5lbl.MouseHover = function(sender, args)
		OptR5lbl:SetBackColor( lightgrey );
		OptR5lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR5lbl.MouseLeave = function(sender, args)
		OptR5lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Position locker activated v**
	local OptR6lbl = Turbine.UI.Label();
	OptR6lbl:SetParent( wOptions );
	OptR6lbl:SetText( tostring( LockPosition ) );
	OptR6lbl:SetPosition( 175, PosY );
	OptR6lbl:SetSize( string.len(OptR6lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR6lbl:SetForeColor( green );
	OptR6lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR6lbl.MouseClick = function(sender, args)
		LockHugeBagPosition();
		OptR6lbl:SetText( tostring( LockPosition ) );
		OptR6lbl:SetSize( string.len(OptR6lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR6lbl.MouseHover = function(sender, args)
		OptR6lbl:SetBackColor( lightgrey );
		OptR6lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR6lbl.MouseLeave = function(sender, args)
		OptR6lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v HugeBag mode v**
	local OptR7lbl = Turbine.UI.Label();
	OptR7lbl:SetParent( wOptions );
	OptR7lbl:SetText( "window mode" );
	if ( Widget ) then OptR7lbl:SetText( "widget mode" ); end
	OptR7lbl:SetPosition( 115, PosY );
	OptR7lbl:SetSize( string.len(OptR7lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR7lbl:SetForeColor( green );
	OptR7lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	--**v Red dot - HugeBag mode v**
	local RedDotLbl2 = Turbine.UI.Label();
	RedDotLbl2:SetParent( wOptions );
	RedDotLbl2:SetText( "*" );
	RedDotLbl2:SetPosition( 6, PosY + 3 );
	RedDotLbl2:SetForeColor( red );
	--**^

	OptR7lbl.MouseClick = function(sender, args)
		ToggleMode();
		--wOptions:Close();
		OptR7lbl:SetText( "window mode" );
		if ( Widget ) then OptR7lbl:SetText( "widget mode" ); end
		OptR7lbl:SetSize( string.len(OptR7lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR7lbl.MouseHover = function(sender, args)
		OptR7lbl:SetBackColor( lightgrey );
		OptR7lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR7lbl.MouseLeave = function(sender, args)
		OptR7lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Show HugeBag skin v**
	local OptR8lbl = Turbine.UI.Label();
	OptR8lbl:SetParent( wOptions );
	OptR8lbl:SetText( tostring(ShowSkin) );
	OptR8lbl:SetPosition( 150, PosY );
	OptR8lbl:SetSize( string.len(OptR8lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR8lbl:SetForeColor( green );
	OptR8lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR8lbl.MouseClick = function(sender, args)
		ToggleSkin();
		OptR8lbl:SetText( tostring( ShowSkin ) );
		OptR8lbl:SetSize( string.len(OptR8lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR8lbl.MouseHover = function(sender, args)
		OptR8lbl:SetBackColor( lightgrey );
		OptR8lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR8lbl.MouseLeave = function(sender, args)
		OptR8lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Orientation of items v**
	local OptR9lbl = Turbine.UI.Label();
	OptR9lbl:SetParent( wOptions );
	OptR9lbl:SetText( "Vertical" );
	if HorizontalOrientation then OptR9lbl:SetText( "Horizontal" ); end
	OptR9lbl:SetPosition( 175, PosY );
	OptR9lbl:SetSize( string.len(OptR9lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR9lbl:SetForeColor( green );
	OptR9lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR9lbl.MouseClick = function(sender, args)
		ToggleItemsOrientation();
		OptR9lbl:SetText( "Vertical" );
		if HorizontalOrientation then OptR9lbl:SetText( "Horizontal" ); end
		OptR9lbl:SetSize( string.len(OptR9lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR9lbl.MouseHover = function(sender, args)
		OptR9lbl:SetBackColor( lightgrey );
		OptR9lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR9lbl.MouseLeave = function(sender, args)
		OptR9lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--[[ Disabled until i found a way to reverse the scrollbar in the same orientation (Top goes to bottom, bottom goes to top)
	--**v Reverse Fill of items v**
	local OptR10lbl = Turbine.UI.Label();
	OptR10lbl:SetParent( wOptions );
	OptR10lbl:SetText( tostring( ReverseFill ) );
	OptR10lbl:SetPosition( 185, PosY );
	OptR10lbl:SetSize( string.len(OptR10lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR10lbl:SetForeColor( green );
	OptR10lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR10lbl.MouseClick = function(sender, args)
		ToggleItemsReverseFill();
		OptR10lbl:SetText( tostring( ReverseFill ) );
		OptR10lbl:SetSize( string.len(OptR10lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR10lbl.MouseHover = function(sender, args)
		OptR10lbl:SetBackColor( lightgrey );
		OptR10lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR10lbl.MouseLeave = function(sender, args)
		OptR10lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	]]
	--**v Always on top v**
	local OptR11lbl = Turbine.UI.Label();
	OptR11lbl:SetParent( wOptions );
	OptR11lbl:SetText( tostring(zOrder) );
	OptR11lbl:SetPosition( 180, PosY );
	OptR11lbl:SetSize( string.len(OptR11lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR11lbl:SetForeColor( green );
	OptR11lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	--**v Red dot - Always on top v**
	local RedDotLbl3 = Turbine.UI.Label();
	RedDotLbl3:SetParent( wOptions );
	RedDotLbl3:SetText( "*" );
	RedDotLbl3:SetPosition( 6, PosY + 3 );
	RedDotLbl3:SetForeColor( red );
	--**^

	OptR11lbl.MouseClick = function(sender, args)
		ToggleAlwaysOnTop();
		OptR11lbl:SetText( tostring( zOrder ) );
		OptR11lbl:SetSize( string.len(OptR11lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR11lbl.MouseHover = function(sender, args)
		OptR11lbl:SetBackColor( lightgrey );
		OptR11lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR11lbl.MouseLeave = function(sender, args)
		OptR11lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;

	--**v Show Button v**
	local OptR13lbl = Turbine.UI.Label();
	OptR13lbl:SetParent( wOptions );
	OptR13lbl:SetText( tostring( ShowButton ) );
	OptR13lbl:SetPosition( 255, PosY );
	OptR13lbl:SetSize( string.len(OptR13lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR13lbl:SetForeColor( green );
	OptR13lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR13lbl.MouseClick = function(sender, args)
		ToggleButton();
		OptR13lbl:SetText( tostring( ShowButton ) );
		OptR13lbl:SetSize( string.len(OptR13lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR13lbl.MouseHover = function(sender, args)
		OptR13lbl:SetBackColor( lightgrey );
		OptR13lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR13lbl.MouseLeave = function(sender, args)
		OptR13lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;

	--**v Inverse Merge v**
	local OptR14lbl = Turbine.UI.Label();
	OptR14lbl:SetParent( wOptions );
	OptR14lbl:SetText( tostring( InverseMerge ) );
	OptR14lbl:SetPosition( 185, PosY );
	OptR14lbl:SetSize( string.len(OptR14lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR14lbl:SetForeColor( green );
	OptR14lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR14lbl.MouseClick = function(sender, args)
		InvMerge();
		OptR14lbl:SetText( tostring( InverseMerge ) );
		OptR14lbl:SetSize( string.len(OptR14lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	end

	OptR14lbl.MouseHover = function(sender, args)
		OptR14lbl:SetBackColor( lightgrey );
		OptR14lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR14lbl.MouseLeave = function(sender, args)
		OptR14lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;

	--**v Show free, used and max slots in shell v**
	local OptR100lbl = Turbine.UI.Label();
	OptR100lbl:SetParent( wOptions );
	OptR100lbl:SetText( "Show HugeBag shell commands" );
	OptR100lbl:SetPosition( 15, PosY );
	OptR100lbl:SetSize( string.len(OptR100lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR100lbl:SetForeColor( green );
	OptR100lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR100lbl.MouseClick = function(sender, args)
		HelpInfo();
	end

	OptR100lbl.MouseHover = function(sender, args)
		OptR100lbl:SetBackColor( lightgrey );
		OptR100lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR100lbl.MouseLeave = function(sender, args)
		OptR100lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Set HugeBag background color v**
	local OptR105lbl = Turbine.UI.Label();
	OptR105lbl:SetParent( wOptions );
	OptR105lbl:SetText( "Set HugeBag background color" );
	OptR105lbl:SetPosition( 15, PosY );
	OptR105lbl:SetSize( string.len(OptR105lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR105lbl:SetForeColor( green );
	OptR105lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR105lbl.MouseClick = function(sender, args)
		SetBackgroundColor();
	end

	OptR105lbl.MouseHover = function(sender, args)
		OptR105lbl:SetBackColor( lightgrey );
		OptR105lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR105lbl.MouseLeave = function(sender, args)
		OptR105lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reset Location and size settings to default v**
	local OptR101lbl = Turbine.UI.Label();
	OptR101lbl:SetParent( wOptions );
	OptR101lbl:SetText( "Reset Location and size settings to default" );
	OptR101lbl:SetPosition( 15, PosY );
	OptR101lbl:SetSize( string.len(OptR101lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR101lbl:SetForeColor( green );
	OptR101lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR101lbl.MouseClick = function(sender, args)
		ResetLSSettings();
		wOptions:Close();
	end

	OptR101lbl.MouseHover = function(sender, args)
		OptR101lbl:SetBackColor( lightgrey );
		OptR101lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR101lbl.MouseLeave = function(sender, args)
		OptR101lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reset all settings to default v**
	local OptR102lbl = Turbine.UI.Label();
	OptR102lbl:SetParent( wOptions );
	OptR102lbl:SetText( "Reset all settings to default" );
	OptR102lbl:SetPosition( 15, PosY );
	OptR102lbl:SetSize( string.len(OptR102lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR102lbl:SetForeColor( green );
	OptR102lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR102lbl.MouseClick = function(sender, args)
		ResetSettings();
		wOptions:Close();
	end

	OptR102lbl.MouseHover = function(sender, args)
		OptR102lbl:SetBackColor( lightgrey );
		OptR102lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR102lbl.MouseLeave = function(sender, args)
		OptR102lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Reload HugeBag v**
	local OptR106lbl = Turbine.UI.Label();
	OptR106lbl:SetParent( wOptions );
	OptR106lbl:SetText( "Reload HugeBag v" .. Version );
	OptR106lbl:SetPosition( 15, PosY );
	OptR106lbl:SetSize( string.len(OptR106lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR106lbl:SetForeColor( green );
	OptR106lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR106lbl.MouseClick = function(sender, args)
		ReloadHugeBag();
	end

	OptR106lbl.MouseHover = function(sender, args)
		OptR106lbl:SetBackColor( lightgrey );
		OptR106lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR106lbl.MouseLeave = function(sender, args)
		OptR106lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 20;
	--**v Unload HugeBag v**
	local OptR107lbl = Turbine.UI.Label();
	OptR107lbl:SetParent( wOptions );
	OptR107lbl:SetText( "Unload HugeBag v" .. Version );
	OptR107lbl:SetPosition( 15, PosY );
	OptR107lbl:SetSize( string.len(OptR107lbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	OptR107lbl:SetForeColor( green );
	OptR107lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );

	OptR107lbl.MouseClick = function(sender, args)
		UnloadHugeBag();
	end

	OptR107lbl.MouseHover = function(sender, args)
		OptR107lbl:SetBackColor( lightgrey );
		OptR107lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
	end

	OptR107lbl.MouseLeave = function(sender, args)
		OptR107lbl:SetBackColor( none );
	end
	--**^
	PosY = PosY + 18;
	--**v Reload Message v**
	local Reloadlbl = Turbine.UI.Label();
	Reloadlbl:SetParent( wOptions );
	Reloadlbl:SetText( "* : Reloading HugeBag required" );
	Reloadlbl:SetPosition( 35, PosY );
	Reloadlbl:SetSize( string.len(Reloadlbl:GetText()) * 7.2, 18 ); --Auto size with text lenght
	Reloadlbl:SetForeColor( red );
	--**^
	-- **v Set the opacity when the mouse enter the window v**
	wOptions.MouseEnter = function( sender, args )
		wOptions:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	wOptions.MouseLeave = function( sender, args )
		wOptions:SetOpacity( 1.0 );
	end

	wOptions.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wOptions:SetVisible(false);
		end
	end
	-- **^
end
-- **^