-- settingsWidget.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	InitXPos, InitYPos = 30, 30; --> ** Initial X & Y position of the first Item in the HugeBag **
	WinWidth, WinHeight = 449, 309; --> ** HugeBag initial size **
	winRate = 30; --> ** rate in screen pixel used to do the slide effect **
	windowOpen = false; --> ** Does widget is hidden are not ( true = showing, false = hidden ) **
	
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWidgetSettings" );

	if settings == nil then settings = {}; end
		
	if settings.Location == nil then
		settings.Location = {};
		settings.Location.Y = tostring(screenHeight - WinHeight - 69);
		settings.Location.Loc = "right";
	else
		if settings.Location.Y == nil then settings.Location.Y = tostring(screenHeight - WinHeight - 69); end
		if settings.Location.Loc == nil then settings.Location.Loc = "right"; end
	end
	WinLocY = tonumber(settings.Location.Y);
	WidgetLoc = settings.Location.Loc;

	-- **v Replace HugeBag if out of the screen on load v**
	if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^

	if settings.BackColor == nil then
		settings.BackColor = {};
		settings.BackColor.A = string.format("%.3f", 0.3);
		settings.BackColor.R = string.format("%.3f", 0.3);
		settings.BackColor.G = string.format("%.3f", 0.3);
		settings.BackColor.B = string.format("%.3f", 0.3);
	else
		if settings.BackColor.A == nil then settings.BackColor.A = string.format("%.3f", 0.3); end
		if settings.BackColor.R == nil then settings.BackColor.R = string.format("%.3f", 0.3); end
		if settings.BackColor.G == nil then settings.BackColor.G = string.format("%.3f", 0.3); end
		if settings.BackColor.B == nil then settings.BackColor.B = string.format("%.3f", 0.3); end
	end
	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);

	if settings.Options == nil then
		settings.Options = {};
		settings.Options.StartVisible = false;
		if HBW then settings.Options.StartVisible = true; end
		settings.Options.HideWEsc = true;
		settings.Options.AlwaysOnTop = false;
		settings.Options.ShowSideBarInfo = "image";
		settings.Options.ShowTopBarInfo = "info";
	else
		if settings.Options.StartVisible == nil then settings.Options.StartVisible = false; end
		if settings.Options.HideWEsc == nil then settings.Options.HideWEsc = true; end
		if settings.Options.AlwaysOnTop == nil then	settings.Options.AlwaysOnTop = true; end
		if settings.Options.ShowSideBarInfo == nil then	settings.Options.ShowSideBarInfo = "image"; end
		if settings.Options.ShowTopBarInfo == nil then settings.Options.ShowTopBarInfo = "info"; end
	end
	StartVisible = settings.Options.StartVisible;
	HideWEsc = settings.Options.HideWEsc;
	zOrder = settings.Options.AlwaysOnTop;
	sidebarinfo = settings.Options.ShowSideBarInfo;
	topbarinfo = settings.Options.ShowTopBarInfo;

	if settings.Button == nil then
		settings.Button = {};
		settings.Button.InverseMerge = false;
		settings.Button.ShowButton = true;
		settings.Button.AtLeft = true;
	else
		if settings.Button.InverseMerge == nil then settings.Button.InverseMerge = false; end
		if settings.Button.ShowButton == nil then settings.Button.ShowButton = true; end
		if settings.Button.AtLeft == nil then settings.Button.AtLeft = true; end
	end
	InverseMerge = settings.Button.InverseMerge;
	ShowButton = settings.Button.ShowButton;
	ButtonAtLeft = settings.Button.AtLeft;
	
	if settings.Button.Position == nil then
		settings.Button.Position = {};
		settings.Button.Position.MidPos = tostring(55);
		settings.Button.Position.Sort = tostring(5);
		settings.Button.Position.Merge = tostring(55);
		settings.Button.Position.Search = tostring(105);
	else
		if settings.Button.Position.MidPos == nil then settings.Button.Position.MidPos = tostring(55); end
		if settings.Button.Position.Sort == nil then settings.Button.Position.Sort = tostring(5); end
		if settings.Button.Position.Merge == nil then settings.Button.Position.Merge = tostring(55); end
		if settings.Button.Position.Search == nil then settings.Button.Position.Search = tostring(105); end
	end
	MidPos = tonumber(settings.Button.Position.MidPos);
	SortLeft = tonumber(settings.Button.Position.Sort);
	SearchLeft = tonumber(settings.Button.Position.Search);
	MergeLeft = tonumber(settings.Button.Position.Merge);
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;

	if settings.WasOpen == nil then settings.WasOpen = false; end
	WasOpen = settings.WasOpen;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.WasOpen = WasOpen;

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	if HBW then settings.Options.StartVisible = true; end
	settings.Options.HideWEsc = HideWEsc;
	settings.Options.AlwaysOnTop = zOrder;
	settings.Options.ShowSideBarInfo = sidebarinfo;
	settings.Options.ShowTopBarInfo = topbarinfo;

	settings.Location = {};
	--settings.Location.X = tostring(WinLocX);
	settings.Location.Y = tostring(WinLocY);
	settings.Location.Loc = WidgetLoc;

	settings.BackColor = {};
	settings.BackColor.A = string.format("%.3f", bcAlpha);
	settings.BackColor.R = string.format("%.3f", bcRed);
	settings.BackColor.G = string.format("%.3f", bcGreen);
	settings.BackColor.B= string.format("%.3f", bcBlue);

	settings.Button = {};
	settings.Button.InverseMerge = InverseMerge;
	settings.Button.ShowButton = ShowButton;
	settings.Button.AtLeft = ButtonAtLeft;

	settings.Button.Position = {};
	settings.Button.Position.MidPos = tostring(MidPos);
	settings.Button.Position.Sort = tostring(SortLeft);
	settings.Button.Position.Search = tostring(SearchLeft);
	settings.Button.Position.Merge = tostring(MergeLeft);

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWidgetSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	WinLocX = screenWidth - WinWidth - 1;
	WinLocY = screenHeight - WinHeight - 69;
	wHugeBag:SetPosition( WinLocX, WinLocY );
	WidgetLoc = "right";
	StartVisible = false;
	WasOpen = false;
	HideWEsc = true;
	InverseMerge = false;
	Widget = Widget;
	bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3;
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	if ( windowOpen ) and ( not StartVisible ) then
		wHugeBag:SetVisible( true );
		slideCtr:SetWantsUpdates(true);
	end
	ButtonAtLeft = true;
	ButtonsPos = "left";
	LeftPos, MidPos, RightPos = 5, 55, 105;
	SortLeft, MergeLeft, SearchLeft = LeftPos, MidPos, RightPos;
	SortButton:SetPosition( SortLeft,  8 );
	SearchButton:SetPosition( SearchLeft,  8 );
	MergeButton:SetPosition( MergeLeft, 8 );
	zOrder = false;
	ToggleSideBarInfo("image");
	ToggleTopBarInfo("info");
	ShowButton = false;
	ToggleBotBarInfo("butvis");
	SaveSettings();
	write( "HugeBag: All my settings was set back to default" );
end
-- **^