-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	InitXPos, InitYPos = 17, 33; --> ** Initial X & Y position of the first Item in the HugeBag **
	WinWidth, WinHeight = 460, 300;
	edgePadding = 15; --> ** HugeBag initial edgePadding value **
	LockLabel = self; --> ** Label that prevents from moving the window cause it's located at top
	ClicX, ClicY = 0, 0; --> To know the x,y coord when mouse button was clic

	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagWindowSettings" );

	if settings == nil then settings = {}; end

	if settings.Size == nil then
		settings.Size = {};
		settings.Size.W = tostring(460);
		settings.Size.H = tostring(300);
	else
		if settings.Size.W == nil then settings.Size.W = tostring(460); end
		if settings.Size.H == nil then settings.Size.H = tostring(300);	end
	end
	WinWidth = tonumber(settings.Size.W);
	WinHeight = tonumber(settings.Size.H);

	if settings.Location == nil then
		settings.Location = {};
		settings.Location.X = tostring(screenWidth - edgePadding - WinWidth);
		settings.Location.Y = tostring(screenHeight - edgePadding - WinHeight - 55);
	else
		if settings.Location.X == nil then settings.Location.X = tostring(Turbine.UI.Display.GetWidth() - edgePadding - WinWidth); end
		if settings.Location.Y == nil then settings.Location.Y = tostring(Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55); end
	end
	WinLocX = tonumber(settings.Location.X);
	WinLocY = tonumber(settings.Location.Y);

	-- Need to go out of bound when no skin on HugeBag
	-- **v Replace HugeBag if out of the screen on load v**
	--if ( WinLocX + WinWidth ) > screenWidth then WinLocX = screenWidth - WinWidth end
	--if ( WinLocY + WinHeight ) > screenHeight then WinLocY = screenHeight - WinHeight end
	-- **^
	
	if settings.BackColor == nil then
		settings.BackColor = {};
		settings.BackColor.A = tostring(1);
		settings.BackColor.R = tostring(0);
		settings.BackColor.G = tostring(0);
		settings.BackColor.B = tostring(0);
	else
		if settings.BackColor.A == nil then	settings.BackColor.A = tostring(1); end
		if settings.BackColor.R == nil then	settings.BackColor.R = tostring(0);	end
		if settings.BackColor.G == nil then settings.BackColor.G = tostring(0); end
		if settings.BackColor.B == nil then	settings.BackColor.B = tostring(0); end
	end
	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);
	
	if settings.Options == nil then
		settings.Options = {};
		settings.Options.StartVisible = false;
		settings.Options.ShowSlotsInfo = true;
		settings.Options.HideWEsc = true;
		settings.Options.LockPosition = false;
		settings.Options.LockSize = false;
		settings.Options.ShowSkin = true;
		settings.Options.ShowTitle = true;
		settings.Options.AlwaysOnTop = true;
	else
		if settings.Options.StartVisible == nil then settings.Options.StartVisible = false; end
		if settings.Options.ShowSlotsInfo == nil then settings.Options.ShowSlotsInfo = true; end
		if settings.Options.HideWEsc == nil then settings.Options.HideWEsc = true; end
		if settings.Options.LockPosition == nil then settings.Options.LockPosition = false; end
		if settings.Options.LockSize == nil then settings.Options.LockSize = false; end
		if settings.Options.ShowSkin == nil then settings.Options.ShowSkin = true; end
		if settings.Options.AlwaysOnTop == nil then	settings.Options.AlwaysOnTop = true; end
	end
	StartVisible = settings.Options.StartVisible;
	ShowSlotsInfo = settings.Options.ShowSlotsInfo;
	HideWEsc = settings.Options.HideWEsc;
	LockPosition = settings.Options.LockPosition;
	LockSize = settings.Options.LockSize;
	ShowSkin = settings.Options.ShowSkin;
	zOrder = settings.Options.AlwaysOnTop;
	
	if settings.Button == nil then
		settings.Button = {};
		settings.Button.InverseMerge = false; -- True => Merge for slot 1 to last slot in bag
		settings.Button.ShowButton = true;
		settings.Button.AtTop = false;
		settings.Button.AtLeft = true;
	else
		if settings.Button.InverseMerge == nil then	settings.Button.InverseMerge = false; end
		if settings.Button.ShowButton == nil then settings.Button.ShowButton = true; end
		if settings.Button.AtTop == nil then settings.Button.AtTop = false; end
		if settings.Button.AtLeft == nil then settings.Button.AtLeft = true; end
	end
	InverseMerge = settings.Button.InverseMerge;
	ShowButton = settings.Button.ShowButton;
	ButtonAtTop = settings.Button.AtTop;
	ButtonAtLeft = settings.Button.AtLeft;
	
	if settings.Button.Position == nil then
		settings.Button.Position = {};
		settings.Button.Position.MidPos = tostring(85);
		settings.Button.Position.Sort = tostring(35);
		settings.Button.Position.Merge = tostring(85);
		settings.Button.Position.Search = tostring(135);
	else
		if settings.Button.Position.MidPos == nil then settings.Button.Position.MidPos = tostring(85); end
		if settings.Button.Position.Sort == nil then settings.Button.Position.Sort = tostring(35); end
		if settings.Button.Position.Search == nil then settings.Button.Position.Search = tostring(85); end
		if settings.Button.Position.Merge == nil then settings.Button.Position.Merge = tostring(135); end
	end
	MidPos = tonumber(settings.Button.Position.MidPos);
	SortLeft = tonumber(settings.Button.Position.Sort);
	MergeLeft = tonumber(settings.Button.Position.Merge);
	SearchLeft = tonumber(settings.Button.Position.Search);
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;
	
	if settings.Items == nil then
		settings.Items = {};
		settings.Items.HorizontalOrientation = true;
		settings.Items.ReverseFill = false;
	else
		if settings.Items.HorizontalOrientation == nil then settings.Items.HorizontalOrientation = true; end
		if settings.Items.ReverseFill == nil then settings.Items.ReverseFill = false; end
		
	end
	HorizontalOrientation = settings.Items.HorizontalOrientation;
	ReverseFill = settings.Items.ReverseFill;

	if settings.WasVisible == nil then settings.WasVisible = StartVisible; end
	WasVisible = settings.WasVisible;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", settings );
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.WasVisible = WasVisible;

	settings.Location = {};
	settings.Location.X = tostring(WinLocX);
	settings.Location.Y = tostring(WinLocY);

	settings.Size = {};
	settings.Size.W = tostring(WinWidth);
	settings.Size.H = tostring(WinHeight);

	settings.Options = {};
	settings.Options.StartVisible = StartVisible;
	settings.Options.ShowSlotsInfo = ShowSlotsInfo;
	settings.Options.HideWEsc = HideWEsc;
	settings.Options.LockPosition = LockPosition;
	settings.Options.LockSize = LockSize;
	settings.Options.ShowSkin = ShowSkin;
	settings.Options.AlwaysOnTop = zOrder;

	settings.BackColor = {};
	settings.BackColor.A = string.format("%.3f", bcAlpha);
	settings.BackColor.R = string.format("%.3f", bcRed);
	settings.BackColor.G = string.format("%.3f", bcGreen);
	settings.BackColor.B = string.format("%.3f", bcBlue);
	
	settings.Button = {};
	settings.Button.InverseMerge = InverseMerge;
	settings.Button.ShowButton = ShowButton;
	settings.Button.AtTop = ButtonAtTop;
	settings.Button.AtLeft = ButtonAtLeft;
	
	settings.Button.Position = {};
	settings.Button.Position.MidPos = tostring(MidPos);
	settings.Button.Position.Sort = tostring(SortLeft);
	settings.Button.Position.Search = tostring(SearchLeft);
	settings.Button.Position.Merge = tostring(MergeLeft);

	settings.Items = {};
	settings.Items.HorizontalOrientation = HorizontalOrientation;
	settings.Items.ReverseFill = ReverseFill;

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagWindowSettings", settings );

	Modesettings = {};
	Modesettings.Widget = Widget;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagMode", Modesettings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	wHugeBag:SetSize( WinWidth, WinHeight );
	wHugeBag:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = wHugeBag:GetPosition();
	wHugeBag:SetVisible( true );
	if not ButtonAtLeft then
		if ( self:GetWidth() >= 218 ) then
			ButtonsLeft();
			ButtonsRight();
		end
	end
	PerformLayout();
	PrintTitle();
	SaveSettings();
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = false;
	HBWasVisible = false;
	ShowSlotsInfo = true;
	HideWEsc = true;
	LockPosition = true;
	LockHugeBagPosition();
	LockSize = true;
	LockHugeBagSize();
	Widget = Widget;
	WinWidth, WinHeight = 460, 300;
	wHugeBag:SetSize( WinWidth, WinHeight );
	wHugeBag:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = wHugeBag:GetPosition()
	bcAlpha, bcRed, bcGreen, bcBlue = 1, 0, 0, 0;
	wHugeBag.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	wHugeBag:SetVisible( true );
	ShowSkin = false;
	ToggleSkin();
	ShowButton = false;
	ToggleButton();
	ButtonAtTop = false;
	ButtonAtLeft = true;
	ButtonsPos = "left";
	InverseMerge = false;
	LeftPos, MidPos, RightPos = 35, 85, 135;
	TopPos = wHugeBag:GetHeight() - 13;
	SortLeft, MergeLeft, SearchLeft = LeftPos, MidPos, RightPos;
	HorizontalOrientation = true;
	--ReverseFill = false;
	zOrder = true;
	PerformLayout();
	PrintTitle();
	SaveSettings();
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^