-- sort.lua
-- Written By MrJackdaw, tweak by Habna for HugeBag


function Sort()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't sort when sort, mix, merge or search function are active!");
		return
	end
	
	local VirtPack = {};

	for i = 1, backpackSize do
		VirtPack[i] = {};
		VirtPack[i].id = i;

		local item = Backpack:GetItem(i);

		if item ~= nil then
			VirtPack[i].Name = item:GetName();

			local Quality = item:GetQuality();
			if Quality == nil then Quality = 0; end

			local Quantity = item:GetQuantity();
			if Quantity == nil then Quantity = 1; end
			VirtPack[i].Quantity = Quantity;

			local Category = item:GetCategory();
			
			if Category == nil then
				CatWeight = 1;
			else
				local CategoryText = ItemCategory[Category];
				
				if CategoryText == nil then CatWeight = 1; else CatWeight = value[CategoryText]; end
			end
			
			VirtPack[i].Weight = CatWeight * 10 + Quality;
		else
			VirtPack[i].Name = "zEmpty";
			VirtPack[i].Quantity = 0;
			VirtPack[i].Weight = 99999;
		end
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters.
	--This way "2 Morale Potions" will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b)	
		if a.Weight == b.Weight then
			if a.Name == b.Name then
				return (a.Quantity < b.Quantity)
			else  
				return strip(a.Name) < strip(b.Name)
			end
		else  
			return (a.Weight < b.Weight) 
		end
		end)
	

	IsSorting = true;
	SortButton:SetVisible( false );
	SearchButton:SetVisible( false );
	MergeButton:SetVisible( false );

	Slot = 1;
	write( "HugeBag: Sorting started" );
	FirstStart= Turbine.Engine.GetGameTime()
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates( true );

	Timer.Update = function( sender, args )
		if Slot > backpackSize then
			Timer:SetWantsUpdates( false );

			if ShowButton then
				SortButton:SetVisible( true );
				SearchButton:SetVisible( true );
				MergeButton:SetVisible( true );
			end
	
			IsSorting = false;
			write( "HugeBag: Sorting finished" );
			local Time = Turbine.Engine.GetGameTime();
			write("<rgb=#888888>Sort finished after ".. Time - FirstStart .." seconds.")
		end
		
		if Slot > backpackSize then return end

		--Get the quantity & name of the target item
		target = VirtPack[Slot].Quantity .. " " .. VirtPack[Slot].Name;
		
		--Search for the item in the rest of the pack.
		for i = Slot, backpackSize do
			item = Backpack:GetItem( i );

			if item ~= nil then
				itemName = item:GetName();
				itemQuantity = item:GetQuantity();
			else
				itemName = "zEmpty";
				itemQuantity = 0;
			end
			source = itemQuantity .. " " .. itemName;
			
			if source == target then
				if Lasti == i then
					Lasti = nil;
					i = i - 1;
				else
					if item ~= nil then Backpack:PerformItemDrop(item, Slot, false); end
					Lasti = i; --Last item move (slot number)
					Slot = Slot + 1;
					return
				end
			end
		end
	end
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right

	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	return str
end